#include <oxstd.h>
#include <arma.h>
#include <oxfloat.h>
#include <oxprob.h>
#include <oxdraw.h>
#import <maximize>


decl k=10,T;

decl df, rho;
const decl p_hs2=3, p_hnu=3;
const decl p_sHbeta=1;
decl p_Hbeta,p_beta;

const decl Gibbsburnin=2000;
const decl Gibbsloops=5000;
const decl loops=10000;
decl y,f, th;


getGibbs()
{
	decl XpX=outer(f~ones(T,1),<>,'o');
	decl H_betai;
	for(decl i=0;i<k;i++){
		
		H_betai=invertsym(p_Hbeta+th[2][i]*XpX);
		th[0:1][i]=H_betai*(p_Hbeta*p_beta+th[2][i]*((f'y[][i])|sumc(y[][i])))+choleski(H_betai)*rann(2,1);
	}
	th[2][]=ranchi(1,k,p_hnu+T)./(p_hs2+sumsqrc(y-f.*th[0][]-th[1][]));
	decl ssi=1/(1+sumr(th[2][].*sqr(th[0][])));
	f=ssi*sumr((y-th[1][]).*th[2][].*th[0][])+sqrt(ssi)*rann(T,1);
}

getscore(const t, const thc)
{
	decl Sig=diag(exp(thc[2][]))+thc[0][]'thc[0][];
	decl Sigi=invertsym(Sig);
	decl scbase=(-thc[0][]*Sigi)~zeros(1,k)~(-.5*diagonal(Sigi).*exp(thc[2][]));
	decl se=(y[t][]-thc[1][])*Sigi;
	decl A=outer(se',<>);
	return scbase+
			((+thc[0][]*A)~se~(.5*diagonal(A).*exp(thc[2][])));
}

getest(thc)
{
	thc[2][]=-log(thc[2][]);
	return thc[1][0]~thc[0][0]~exp(.5*thc[2][0]);
}
getestx(decl thc)
{
	return thc[1][0]~thc[0][0]~exp(.5*thc[2][0]);
}

decl mindata;

decl linexb=2;

linex(const x)
{
	return min(exp(linexb*sqrt(T)*x)-linexb*sqrt(T)*x-1,30);
}

flinex(const a, const adLoss, const dum1, const dum2)
{
	decl d=(sqrt(T)*linexb)*(a-mindata);
	adLoss[0]=-meanc(setbounds(exp(d)-d-1,0,30));	
	return 1;
}

minlinex()
{
	decl loss,a=0;
	MaxBFGS(flinex,&a,&loss,0,1);
	return a;		
}

decl HPDc=40;
fHPD(const a, const adLoss, const dum1, const dum2)
{
	decl al=a[0];
	decl au=al+exp(a[1]);
	adLoss[0]=-meanc(setbounds(
			sqrt(T)*(au-al+HPDc*(mindata.<al).*(al-mindata)+HPDc*(mindata.>au).*(mindata-au))
			,0,80));	
	return 1;
}


minHPD()
{
	decl loss,a=quantilec(mindata,(1/HPDc)~(1-1/HPDc));
	MaxBFGS(fHPD,&a,&loss,0,1);
	return a[0]|(a[0]+exp(a[1]));		
}

HPD(const a)
{
	return min(sqrt(T)*(a[1]-a[0]+HPDc*(a[0]>0)*a[0]+HPDc*(a[1]<0)*(-a[1])),80);
}


lossprint(const x)
{
	for(decl i=0;i<rows(x);i++)
		print(shape(x[i][],4,6)./shape(x[i][],4,6)[3][]);
}

main()
{
	decl args=arglist(),rs;
	if (rows(args)>1) sscan(args[1],"%d",&rs); else rs=0;
	println("seed=",rs);
if(rs==0) rs=1;
	if(rs>0)
		[T,k,df,rho]={
			{50,5,1000,0.0},
			{100,5,1000,0.0},
			{200,5,1000,0.0},

			{50,5,8,0.0},
			{100,5,8,0.0},
			{200,5,8,0.0},

			{50,5,1000,0.3},
			{100,5,1000,0.3},
			{200,5,1000,0.3}

			}[rs-1];

	format(5000);
	ranseed(25);
	p_Hbeta=p_sHbeta*unit(2);
	p_beta=ones(2,1);

	decl loss=zeros(6,3);
	decl cumloss=loss;
	decl losslist=zeros(loops,6*3);
	for(decl lc=0;lc<loops;lc++){

	th=ones(3,k);
	decl th0=th;
	decl est0=getest(th0);
	y=cumsum(
		(sqrt((df-2)/df)*rant(1,k,df))|
		(sqrt(1-rho^2)*sqrt((df-2)/df)*rant(T,k,df))
			,rho)[1:][].*((th[2][]).^(-.5));
	f=cumsum(
		(sqrt((df-2)/df)*rant(1,1,df))|
		(sqrt(1-rho^2)*sqrt((df-2)/df)*rant(T,1,df))
			,rho)[1:][];
	y+=th[0][].*f;
	y+=th[1][];
	
	for(decl j=0;j<Gibbsburnin;j++){
		getGibbs();
	}
	decl nest=3;
	decl thlist=zeros(Gibbsloops,3*k);
	decl estlist=zeros(Gibbsloops,nest);
	for(decl j=0;j<Gibbsloops;j++){
		getGibbs();
		thlist[j][]=vecr(th)';	
		estlist[j][]=getest(th);
	}

	thlist=thlist[][0:2*k-1]~(-log(thlist[][2*k:]));

	decl S=quantilec(thlist,<0.25,0.75>);
	S=diag((S[1][]-S[0][])/1.34896);
	decl thranks=thlist;
	decl rind=range(0,rows(thlist)-1)';
	for(decl i=0;i<columns(thlist);i++)
		thranks[sortbyc(thlist[][i]~rind,0)[][1]][i]=rind;

	decl Hi=S*2*sin((M_PI/6)*correlation(thranks))*S;
	decl thm=reshape(quantilec(thlist),3,k);
	
	decl slist=zeros(T,3*k);
	decl sc2=zeros(3*k,3*k);
	for(decl t=0;t<T;t++){
		slist[t][]=getscore(t,thm);
	}
	sc2=outer(slist,<>,'o')+diagcat(p_Hbeta**unit(k),diag(.5*p_hnu*exp(-thm[2][])));	
	decl SigS=Hi*sc2*Hi;

	for(decl i=1;i<=3;i++){
		decl G=slist[i:][]'slist[0:T-1-i][];
		sc2+=(1-i/4)*(G+G');
	}
	decl SigS2=Hi*sc2*Hi;

	decl Slist={SigS,SigS2};
	for(decl i=0;i<rows(Slist);i++){
		decl SC=choleski(Slist[i]);
		decl eestlist=zeros(2000,nest);
		for(decl j=0;j<2000;j++)
			eestlist[j][]=getestx(thm+reshape((SC*rann(3*k,1))',3,k));
		for(decl j=0;j<3;j++){
			mindata=eestlist[][j]-est0[j];
			loss[i][j]=HPD(minHPD());
			loss[3+i][j]=linex(minlinex());
		}
	}

	for(decl j=0;j<3;j++){
		mindata=estlist[][j]-est0[j];
		loss[2][j]=HPD(minHPD());
		loss[5][j]=linex(minlinex());
	}

	losslist[lc][]=vec(loss)';
	cumloss+=loss;
	}

	decl allout=zeros(12,9);
	decl alloutraw=zeros(18,9);
	decl alloutstd=allout;

	cumloss/=loops;
	decl nc=imod(rs-1,3);
	decl dgpc=idiv(rs-1,3);
	
	for(decl i=0;i<3;i++){
		allout[2*nc:2*nc+1][3*i+dgpc]=cumloss[<0,1>][i]/cumloss[2][i];
		allout[6+2*nc:6+2*nc+1][3*i+dgpc]=cumloss[<3,4>][i]/cumloss[5][i];

		alloutraw[3*nc:3*nc+2][3*i+dgpc]=cumloss[0:2][i];
		alloutraw[9+3*nc:9+3*nc+2][3*i+dgpc]=cumloss[3:5][i];

		alloutstd[2*nc:2*nc+1][3*i+dgpc]=sqrt(varc(losslist[][6*i+<0,1>]/cumloss[2][i]-(cumloss[<0,1>][i]').*losslist[][6*i+2]./sqr(cumloss[1][i]))'/loops);
		alloutstd[6+2*nc:6+2*nc+1][3*i+dgpc]=sqrt(varc(losslist[][6*i+<3,4>]/cumloss[5][i]-(cumloss[<3,4>][i]').*losslist[][6*i+5]./sqr(cumloss[4][i]))'/loops);

	}
	savemat(sprint("allout",rs,".mat"),allout|alloutraw|alloutstd);
	print(allout,alloutraw,alloutstd);
}