dlibrary -a PszTgSen,PsdTgSen;

/* Model Specification
**
** 1 = Fed reacts to current inflation, likelihood  = det + indet
** 2 = Fed reacts to current inflation, likelihood  = det 
** 3 = Fed reacts to current inflation, likelihood  = indet
**
** 4 = Fed reacts to expected inflation, likelihood = det + indet
** 5 = Fed reacts to expected inflation, likelihood = det
** 6 = Fed reacts to expected inflation, likelihood = indet
*/
mspec = 2;
lmodel = "m" $+ ftos(mspec,"%*.*lf",1,0) ;

mprior = 1;
lprior = ftos(mprior,"%*.*lf",1,0);

npara  = 17;

/* para_mask 
**   to fix a parameter set the corresponding
**   element of para_mask to 1
** para_fix 
**   contains the values for the fixed parameters (all other entries
**   are irrelevant)
*/

para_mask    = zeros(npara,4); 
  /* 1. fix none */
  /* 2. fix M */            para_mask[11:13,2] = ones(3,1); 
  /* 3. fix sig(zeta) */    para_mask[17,3] = 1;
  /* 4. fix M, sig(zeta) */ para_mask[11:13,4] = ones(3,1); para_mask[17,4] = 1; 
  
para_maskinv = ones(npara,4) - para_mask;
para_fix     = zeros(npara,4);

/* Controls the fixing of parameters
*/
subT = 1;   

if (mspec == 2) OR (mspec == 5);
   subT = 4;
endif;

subTstr = ftos(subT,"%*.*lf",1,0);

/* Selected data set
** 0 = actual, full, HP filtered
** 1 = actual, Pre-Volcker, HP filtered
** 2 = actual, Volcker-Greenspan, HP filtered
** 3 = actual, post-82, HP filtered
** 4 = actual, full, linear trend
** 5 = actual, Pre-Volcker, linear trend
** 6 = actual, Volcker-Greenspan, linear trend
** 7 = actual, post-82, linear trend
** i = simulated data set i
*/
datasel    = 0;
dataselstr = ftos(datasel,"%*.*lf",1,0);

/* Subperiods in CGG
** Pre-Volcker:       1960:1 to 1979:2, obs  1 -  78
** Volcker-Greenspan: 1979:3 to 1997:4, obs 79 - 152
** post-82:           1982:4 to 1997:4, obs 92 - 152
*/

/* Specify sample length for artificial data
*/

Tsimtotal = 10000;
Tsimburn  = 1000;
/* Length of artificial sample [i]
** Note samples 0-7 are actual -> Tsim = 0
*/
Tsim      =  0 | 0 | 0 | 0 | 0 | 0 | 0 | 200 ;
     
 
